"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.parseVmList = undefined;

var _bluebirdLst;

function _load_bluebirdLst() {
    return _bluebirdLst = require("bluebird-lst");
}

let parseVmList = exports.parseVmList = (() => {
    var _ref = (0, (_bluebirdLst || _load_bluebirdLst()).coroutine)(function* () {
        let rawList = yield (0, (_builderUtil || _load_builderUtil()).exec)("prlctl", ["list", "-i", "-s", "name"]);
        rawList = rawList.substring(rawList.indexOf("ID:"));
        // let match: Array<string> | null
        const result = [];
        for (const info of rawList.split("\n\n").map(function (it) {
            return it.trim();
        }).filter(function (it) {
            return it.length > 0;
        })) {
            const vm = {};
            for (const line of info.split("\n")) {
                const meta = /^([^:("]+): (.*)$/.exec(line);
                if (meta == null) {
                    continue;
                }
                const key = meta[1].toLowerCase();
                if (key === "id" || key === "os" || key === "name") {
                    vm[key] = meta[2].trim();
                }
            }
            result.push(vm);
        }
        return result;
    });

    return function parseVmList() {
        return _ref.apply(this, arguments);
    };
})();

exports.execParallels = execParallels;
exports.macPathToParallelsWindows = macPathToParallelsWindows;

var _builderUtil;

function _load_builderUtil() {
    return _builderUtil = require("builder-util");
}

function execParallels(vm, file, args, options) {
    return (0, (_builderUtil || _load_builderUtil()).exec)("prlctl", ["exec", vm.id, file.startsWith("/") ? macPathToParallelsWindows(file) : file].concat(args), options);
}
function macPathToParallelsWindows(file) {
    return "\\\\Mac\\Host\\\\" + file;
}
//# sourceMappingURL=parallels.js.map